#ifndef __NAND_EXTERN_H__
	#define __NAND_EXTERN_H__

#include "Nand\NandConfig.h"
#include "DriverDef.h"

/* ------------  OS Layer Function Extern  -----------------*/
extern	int  NAND_OS_Init (void);
extern	void NAND_OS_LOCK(void);
extern	void NAND_OS_UNLOCK(void);
extern	int  NAND_OS_Exit (void);
extern  int  NAND_OS_PHY_Init (void);
extern  void NAND_OS_PHY_LOCK(void);
extern  void NAND_OS_PHY_UNLOCK(void);
extern  void Sys_Exception(int errorcode);

/* ------------  Physical Layer Function Extern  ---------- */
extern 	INT CheckDMABusy(int Channel);
extern 	INT CheckNandBusy(void);
extern 	INT ReadNANDStatus_Byte(void);
extern	void ReadBENANDECCStatus_Byte(INT* ECCBits);
extern 	INT BCH8_decode(INT total_page, INT *database,UINT *count);
extern 	INT BCH4_decode(INT total_page, INT *database,UINT *count);

extern 	INT Nand_ErasePhysicalBlock(WORD);
extern 	INT Nand_WritePhysicalPage(DWORD, DWORD);
extern 	INT Nand_ReadPhysicalPage(DWORD, DWORD);
extern 	INT Nand_CacheWritePhysicalPage2K(DWORD, DWORD );
extern 	INT Nand_ReadPhysicalCFlag(DWORD PageAddr,WORD offset,WORD Len,WORD* DataAddr);

extern 	void NandReset(void);
extern 	void NandHwInitial(void);
extern 	void NAND_ReadID(DWORD*);
extern 	INT Nand_ErasePhyBlock(WORD );
extern 	INT Nand_WritePhyPage(DWORD, DWORD );
extern 	INT Nand_ReadPhyPage(DWORD, DWORD );
extern 	void DMAmmCopy(DWORD, DWORD, WORD );
extern 	void memset_w(WORD *p, WORD value, WORD count);
extern 	WORD GetCArea(WORD byte_ofs);
extern 	WORD GetCArea_bk(WORD byte_ofs);
extern 	WORD GetCArea_Boot(WORD byte_ofs);
extern 	void PutCArea(WORD byte_ofs,WORD data);
extern 	void PutCArea_bk(WORD byte_ofs,WORD data);
extern  void PutCArea_Boot(WORD byte_ofs,WORD data);

/* --------------  Manage Layer Function  Extern	------------*/
extern 	INT GetNandParam(void);
extern 	void GlobalVarInit(void);
extern 	DWORD GetNandSize(void);
extern 	INT CalculateFATArea(void);
extern 	INT ReadHeadFromNand(void);
extern 	INT ReadMapTableFromNand(WORD wBankNum);
extern 	WORD ReadLogicNumFromNand(WORD wPhysicBlkNum);
extern 	WORD WriteMapTableToNand(WORD wBankNum);
extern 	WORD FindMapTableCurrentPage(WORD wPhysicBlk);
extern 	WORD FindNandHeadCurrentPage(WORD wPhysicBlk);
extern 	WORD GetFreeBlkFromRecycleFifo();
extern 	void PutFreeBlkIntoRecycleFifo(WORD wPhysicBlkNum);
extern 	INT ReadDataFromNand(DWORD wPhysicPageNum);
extern 	INT ReadDataFromNand_BK(DWORD wPhysicPageNum);
extern 	INT WriteDataIntoNand(DWORD wPhysicPageNum);
extern 	INT WriteDataIntoNand_BK(DWORD wPhysicPageNum);
extern 	INT EraseNandBlk(WORD wPhysicBlkNum);
extern 	void UpdateMaptable(WORD wSwapBlkNum, WORD wLogicNum);
extern 	int FixupIllegalBlock(WORD* pIllegalTable , WORD wCount);
extern 	INT NandFlushA(WORD wBlkIndex,WORD TargetBank,INT wMode);
extern 	INT NandFlushB(void);
extern 	void ChangeBank(WORD wBankNum);
extern 	WORD FindBlkCurrentPage(WORD wPhysicBlk , WORD wBlkID);
extern 	INT NandXsfer(DWORD wLBA, WORD wLen, DWORD wAddr,WORD XsferMode);
extern 	INT PowerOffSaveNandHead(void);
extern 	WORD CopyMultiPhysicalPage(WORD wSRCBlkNum, WORD wTARBlkNum, WORD wStartPage, WORD wEndPage, WORD wLogicBlkNum);
extern 	WORD CopyMultiPhysicalPage_A(WORD wSRCBlkNum, WORD wTARBlkNum, WORD wStartPage, WORD wEndPage, WORD wLogicBlkNum);// zurong add
extern 	void SetBadFlagIntoNand(WORD wPhysicBlkNum, WORD ErrFlag, WORD WorkBuffer_Type);

/* ----------- BootLoader Area	Function Extern  -------------- */
extern 	WORD GetNandID(void);
extern 	WORD CheckOrgBadBlk(WORD wPhysicBlkNum);
extern 	WORD GetSwapPhysicBlock(void);
extern 	WORD GetMapTblInfo(WORD wPhysicBlk);
extern 	INT CopyPageToPage(WORD wSrcBlock,WORD wTargetBlock,WORD wPage);
extern 	WORD PutSwapPhysicBlock(WORD wPhysicBlock);
extern 	INT UpdateL2PTbl(WORD wLogicNum,WORD wPhysicNum);
extern 	WORD GetPhysicBlockNum(WORD wLogicNum);
extern 	void BootSetBadFlag(WORD wPhysicBlkNum, WORD ErrFlag);
extern 	INT BootReadPage(DWORD wPhysicPageNum,DWORD DataAddr);
extern 	INT NandBootEraseLogicBlk(WORD wLogicBlk);

/* -------------  MP3 Function Extern --------------- */
extern 	INT ReadMapTableFromNand_MP3(WORD wBankNum);
extern 	INT ReadDataFromNand_MP3(DWORD wPhysicPageNum);
extern 	INT NandXsfer_MP3(DWORD wLBA, WORD wLen, DWORD wAddr,WORD XsferMode);

/* -------------  User Interface Extern ------------ */
//extern 	void GetNandInfo(NF_USER_INFO *user_info);
//extern 	INT GetNandInfo(NF_USER_INFO *user_info);
extern 	INT GetNandInfo(void);
extern 	void SaveBadBlkInfo(WORD wBlkNum);
extern 	INT ChangeReadErrBlk(void);

extern  void Nand_Write_Enable(void);		//wwj add
extern  void Nand_Write_Disable(void);		//wwj add

/* ------------- Global Varible Extern ------------ */
extern 	WORD  			gNandInitDone;
extern 	WORD  			gNandWrite;

//   FAT Global
extern 	DWORD 			Nand_Part0_Offset;
extern 	DWORD 			Nand_Part0_Size;
extern 	DWORD 			Nand_Part1_Offset;
extern 	DWORD 			Nand_Part1_Size;
extern 	const int		FATNandTable[];
extern 	DWORD 			gFirstFATStart;
extern 	DWORD 			gFirstFATDataStart;
extern 	DWORD 			gSecondFATStart;
extern 	DWORD 			gSecondFADataStart;

extern 	EXCHANGE_A_BLK	gExchangeABlock[];
extern 	EXCHANGE_B_BLK	gExchangeBBlock;

extern 	DWORD 			gNandSize;

extern 	NAND_HEAD 		gHead;
extern 	NAND_HEAD 		gHead_BK;
extern 	BANK_INFO 		gBankInfo[];
extern 	BANK_INFO 		gBankInfo_BK[];
extern 	DWORD 			gBankInfoCheckSum_BK;
extern 	DWORD 			gBankInfoCheckSum;

extern 	MM 				mm[];
extern 	TT 				tt;
extern 	TT 				tt_bk;
extern  TT 				tt_APP;

//extern 	MM 				mm_MP3;
//extern 	TT 				tt_MP3;
extern  MP3_MM_TYPE				mm_MP3;		//wwj modify
extern  MP3_TT_TYPE				tt_MP3;		//wwj modify

extern 	WORD			gMaptableChanged[];

extern 	WORD    			gCurrentBankNum;
extern 	WORD    			gCurrentBankNum_MP3;
extern 	DWORD 				gLastPage;
extern 	DWORD   			gLastPage_MP3;

extern 	L2P   				gL2PTable[];
extern 	WORD  				gBootCurrPage;
extern 	WORD  				gBootCurrLogicBlk;
extern 	WORD  				gBootCurrPhysicBlk;
extern 	WORD  				gBootCurrSector;

extern 	NF_USER_INFO		gNandUserInfo;
extern 	NF_USER_INFO		*pNandUserInfo;
extern 	NF_PHY_INFO			gNandPhyInfo;

extern 	WORD				gNandBlk2SectorShift;
extern 	WORD				gNandBlk2PageShift;
extern 	WORD				gNandPage2SectoShift;

extern  WORD			gNandBlockNum;

#ifdef USB_UPDATE
extern WORD 				gTotalBankNum;
extern WORD 				gPhyBlkNum;
extern WORD 				gFlushType1;
extern WORD 				gFlushType0;
extern WORD 				gInitialFlag;
#endif

extern 	BAD_BLK_ARRAY 		bad_blk_info;	//wwj mark, 20090421

extern  UINT	R_NF_Ctrl;			//wwj add, 20090421
extern  UINT	R_Burst_Read;		//wwj add, 20090421
extern  UINT	R_Burst_Write;		//wwj add, 20090421

#endif