///////////////////////////////////////////////////////////////////////////////
// Description: GPL951 USB Function File,User can modify for your requiredment
// Plateform: GPL951, unSP IDE 
// Edited and Created by Generalplus Technology Co., Ltd. 
///////////////////////////////////////////////////////////////////////////////
//*****************************************************************************
//*****************************************************************************
// Header File Included Area
//*****************************************************************************
//*****************************************************************************
#include "GPL951_Body.h"
#include "USB\USBD_Define.h"
#include "USB\USBD.h"
#include "NAND\NandDrv.h"

unsigned long Testval = 0x40000;

//====================================================================================================
//	Description:	Read 10
//	Function:		Read_10()
//	Syntax:			int Read_10(unsigned long  lUSB_LUN_Read)
//	Input Paramter:	unsigned long  lUSB_LUN_Read: Struct USB LUN Information
//	Return: 		1: Fail, 0: Success			
//====================================================================================================
int Read_10(unsigned long  lUSB_LUN_Read)
{
	int i;//, j;
	unsigned long SCSI_LBA;
	unsigned int SCSI_Transfer_Length;
	unsigned long USB_RW_Buffer_PTR, USB_RW_Buffer_PTR_A,USB_RW_Buffer_PTR_B,USB_RW_Buffer_PTR_Temp;
	int ret,stage;
	unsigned int USBDMA_CHANNEL0, USBDMA_CHANNEL1;
	
	str_USB_Lun_Info*  ptr_USB_LUN_Read;
	ptr_USB_LUN_Read = (str_USB_Lun_Info*)lUSB_LUN_Read;
	ulTimeout = 0x4FFFF;
	ret=0x00;
	stage = 0x00;
	Sense_Code = 0;
	R_USB_RW_Busy = 1;
		
	SCSI_LBA=GetLBA();
	
	SCSI_Transfer_Length=GetTransLeng();
	
	USB_RW_Buffer_PTR=GetBufferPointer();
	USB_RW_Buffer_PTR_A=USB_RW_Buffer_PTR;   //add by zhangxh 2006/01/19
	USB_RW_Buffer_PTR_B=USB_RW_Buffer_PTR_A + 256;	

	USBDMA_CHANNEL0 = 0;
	USBDMA_CHANNEL1 = 1;

	if(1)
	{
		if ((SCSI_LBA + SCSI_Transfer_Length)>ptr_USB_LUN_Read->ulNandSizeSec)	//check read address overflow
		{
			Sense_Code = 0x1B;
			ret = 1;
			goto End;
		}
		
		if(ptr_USB_LUN_Read->unLunType == LunType_CDROM)	//CDROM, do not modify below CDROM code
		{
			SCSI_LBA ++;						
			SCSI_LBA = SCSI_LBA << 2;						//1 sector = 4 *512
			SCSI_LBA += ptr_USB_LUN_Read->ulNandStartAddr;		
			SCSI_Transfer_Length = SCSI_Transfer_Length << 2; //length *4
		}
		else
			SCSI_LBA += ptr_USB_LUN_Read->ulNandStartAddr;		

		for(i=0 ; i < SCSI_Transfer_Length ; i++)
		{
			if(SCSI_LBA+i == Testval)
				SCSI_LBA = SCSI_LBA;
			
			
			ret = NandReadSector((unsigned long)(SCSI_LBA+i), 1, (unsigned long)USB_RW_Buffer_PTR_A);
 			if (stage)
			{
				TXToUSB_USB(USB_RW_Buffer_PTR_A, 0x01, USBDMA_CHANNEL1, 0x01);
				
				ulTimeout = 0x4FFFF;
				while((*P_USBD_EPEvent & 0x0100) != 0)
				{						
					if (!(ulTimeout--))	
					{
						*P_USBD_EPEvent=0x0600;	
						Sense_Code = 0x12; 
						ret = 1;
						goto End;
					}
				}
				*P_USBD_EPEvent=0x0600;
			}
														
			TXToUSB_USB(USB_RW_Buffer_PTR_A, 0x01, USBDMA_CHANNEL1, 0x00);
			stage=1;
								
			if (i == SCSI_Transfer_Length-1)
			{
				TXToUSB_USB(USB_RW_Buffer_PTR_A, 0x01, USBDMA_CHANNEL1, 0x01);
				ulTimeout = 0x4FFFF;
				while((*P_USBD_EPEvent & 0x0100) != 0)
				{						
					if (!(ulTimeout--))	
					{
						*P_USBD_EPEvent=0x0600;	
						Sense_Code = 0x12; 
						ret = 1;
						goto End;
					}
				}
				*P_USBD_EPEvent=0x0600;
			}
			USB_RW_Buffer_PTR_Temp = USB_RW_Buffer_PTR_B;			
			USB_RW_Buffer_PTR_B = USB_RW_Buffer_PTR_A;
			USB_RW_Buffer_PTR_A = USB_RW_Buffer_PTR_Temp;
		}		

		CSW_Residue=0x00;
	}
End:	
	return ret;
}

//====================================================================================================
//	Description:	Write 10
//	Function:		Write_10()
//	Syntax:			int Write_10(unsigned long  lUSB_LUN_Write)
//	Input Paramter:	unsigned long lUSB_LUN_Write: Struct USB LUN Information
//	Return: 		1: Fail, 0: Success			
//====================================================================================================
int Write_10(unsigned long	lUSB_LUN_Write)
{
	int j;
	unsigned long SCSI_LBA;
	unsigned int SCSI_Transfer_Length;
	unsigned long USB_RW_Buffer_PTR;
	unsigned long USB_RW_Buffer_PTR_A,USB_RW_Buffer_PTR_B,USB_RW_Buffer_PTR_Temp;
	unsigned int USBDMA_CHANNEL0, USBDMA_CHANNEL1;
	int ret= 0xffff/* , stage = 0 */;
	int ret1=0xffff;
	unsigned int Erro_Flag = 0;
	str_USB_Lun_Info*  ptr_USB_LUN_Write;
	
	ptr_USB_LUN_Write = (str_USB_Lun_Info*)lUSB_LUN_Write;
	R_USB_RW_Busy = 1;
	Sense_Code = 0x00;
	SCSI_LBA=GetLBA();
	SCSI_Transfer_Length=GetTransLeng();
	USB_RW_Buffer_PTR=GetBufferPointer();

	USB_RW_Buffer_PTR_A=GetBufferPointer();   //add by zhangxh 2006/01/19
	USB_RW_Buffer_PTR_B=USB_RW_Buffer_PTR_A + 256;

	USBDMA_CHANNEL0 = 0;
	USBDMA_CHANNEL1 = 1;

	if(1)
	{
		j=0;

		if ((SCSI_LBA + SCSI_Transfer_Length)>ptr_USB_LUN_Write->ulNandSizeSec)	//check address overflow	
		{
			Sense_Code = 0x1B;//LOGICAL BLOCK ADDRESS OUT OF RANGE
			ret = 1;			
			goto End;
		}
			if(SCSI_LBA == 0x031e)
				SCSI_LBA = SCSI_LBA;
	
		SCSI_LBA += ptr_USB_LUN_Write->ulNandStartAddr;		
		
	
							
		for(j=0; j<(SCSI_Transfer_Length); j++)
		{				
			if(SCSI_LBA+j == Testval)
				SCSI_LBA = SCSI_LBA;
			
			
			
			if (j==0)
			{
				ret=Receive_From_USB_DMA_USB(USB_RW_Buffer_PTR_A, USBDMA_CHANNEL1);//Get first sector
				Erro_Flag = CheckUSBRxReady(1);
				*P_USBD_EPEvntClear=0x0010;			
				*P_USBD_EPEvent=0x2000;		// Bulk OUT NACK Reset
				if (Erro_Flag != 0x00)
					break;
			}
			else 
			{				
				Erro_Flag = CheckUSBRxReady(1);
				*P_USBD_EPEvntClear=0x0010;			
				*P_USBD_EPEvent=0x2000;		// Bulk OUT NACK Reset	
				if (Erro_Flag != 0x00)
					break;
						
			}					

			if (j != (SCSI_Transfer_Length-1))
				ret=Receive_From_USB_DMA_USB(USB_RW_Buffer_PTR_B, USBDMA_CHANNEL1);
				
			//=================================================================================================
			if(SCSI_LBA == 0x8000)
				SCSI_LBA = SCSI_LBA;
			
			
			ret1 = NandWriteSector((unsigned long)SCSI_LBA+j, 1, (unsigned long)USB_RW_Buffer_PTR_A);	
		
			if (ret1 != 0x00)
				break;

			USB_RW_Buffer_PTR_Temp = USB_RW_Buffer_PTR_B;
			USB_RW_Buffer_PTR_B = USB_RW_Buffer_PTR_A;
			USB_RW_Buffer_PTR_A = USB_RW_Buffer_PTR_Temp;
		}//j

		if(ret != 0x00)
		{
			CSW_Residue=SCSI_Transfer_Length-j-1;
			CSW_Residue=CSW_Residue << 9;
			Sense_Code=0x10;	//WRITE FAULT
		}
		else
			CSW_Residue=0;
		
	}

End:	
	return ret;	
}

//====================================================================================================
//	Description:	Call back function
//	Function:		TestUnitReady_CallBack()
//	Syntax:			unsigned int TestUnitReady_CallBack(void)
//	Input Paramter:	None
//	Return: 		1: meansuser modify reply value and default process will be skip,
//				 	0: it will run default process			
//====================================================================================================
unsigned int TestUnitReady_CallBack(void)
{	
	return 0;
}

//====================================================================================================
//	Description:	Call back function
//	Function:		ModeSense6_CallBack()
//	Syntax:			unsigned int ModeSense6_CallBack(void)
//	Input Paramter:	None
//	Return: 		1: meansuser modify reply value and default process will be skip,
//				 	0: it will run default process			
//====================================================================================================
unsigned int ModeSense6_CallBack(void)
{	
	return 0;	
}

//====================================================================================================
//	Description:	Call back function
//	Function:		VendorCmd_CallBack()
//	Syntax:			void VendorCmd_CallBack(void)
//	Input Paramter:	None
//	Return: 		None		
//====================================================================================================
void VendorCmd_CallBack(void)
{	
	CommandFail(0x1A);	//unsupport command
}

//====================================================================================================
//	Description:	This function will be called if PC run to be suspend or device be plug out.
//	Function:		USBDSuspend_CallBack()
//	Syntax:			void USBDSuspend_CallBack(void)
//	Input Paramter:	None
//	Return: 		None		
//====================================================================================================
void USBDSuspend_CallBack(void)
{
	//set R_USB_Suspend=1 will break out usb service loop.
	R_USB_Suspend=1;
	NandFlushAllBlk();	
}

//====================================================================================================
//	Description:	This function will be called if PC run to be suspend or device be plug out.
//	Function:		EP0_DataPointer_CallBack()
//	Syntax:			int EP0_DataPointer_CallBack(int nTableType)
//	Input Paramter:	Descriptor address
//	Return: 		1: if you want to redirect R_Descriptor_High and R_Descriptor_Low address.
//					0: use default reply info.		
//====================================================================================================
int EP0_DataPointer_CallBack(int nTableType)
{	
	return 0;
}

//====================================================================================================
//	Description:	Setup CDRom timer, user can assigned TimeA~TimeD as timer register.
//					Be careful in IRQ4, will change CDDelay parameter value. If user do not use CDROM
//					function, this function will not be used.
//	Function:		CDROMTimerStartup()
//	Syntax:			void CDROMTimerStartup(void)
//	Input Paramter:	None
//	Return: 		None	
//====================================================================================================
void CDROMTimerStartup(void)
{
	*P_TimerD_Preload=0x10000-4096;	//enable timerD and set timer
    *P_TimerD_Ctrl=0xe064;
}

//====================================================================================================
//	Description:	Setup CDRom timer, user can assigned TimeA~TimeD as timer register.
//					Be careful in IRQ4, will change CDDelay parameter value. If user do not use CDROM
//					function, this function will not be used.
//	Function:		CDROMTimerOccur()
//	Syntax:			void CDROMTimerOccur(void)
//	Input Paramter:	None
//	Return: 		None	
//====================================================================================================
void CDROMTimerOccur(void)
{
//	int nTrigger;
//	
//	nTrigger = (*P_INT_Status2) & C_INT_TimerD;
//	if (nTrigger)	
//	{		
//	    CDROMDelay = 0;	
//		*P_TimerD_Ctrl = 0x8064;	//Disable timer
//	}
}

