//main.c
#include "GPL951_Body.h"
#include "System\System.h"
#include "USB\USBD_Define.h"
#include "USB\USBD.h"
#include "NAND\DriverDeclare.h"
#include "NAND\NandDrv.h"


DWORD Nand_Part0_Offset		= 0;
DWORD Nand_Part0_Size		= 0x50000;
DWORD Nand_Part1_Offset 	= 0x50000;
DWORD Nand_Part1_Size		= 0x50000;
DWORD Nand_Part2_Offset		= 0;
DWORD Nand_Part2_Size		= 0;
DWORD Nand_Reserve_Offset 	= 0;
DWORD Unitab_Sector_Offset;

extern DWORD gFirstFATStart;
extern DWORD gFirstFATEnd;
extern DWORD gSecondFATStart;
extern DWORD gSecondFATEnd;
extern DWORD gNandSize;
extern WORD  gMaxFAT1AreaLen;
extern WORD  gMaxFAT2AreaLen;

str_USB_Lun_Info USB_Lun_Define[1];

extern void memset_dw(unsigned long*, unsigned long value, int count);


int main()
{
	//add your code here
	int i,ret;
    int Key;
    						
	Key = 0;
 	System_Initial();
	
	*P_IOC_Drv = 0x0040 + 0x002a;		//NAND interface initial
	*P_IOC_Mux = 0x0040;		
	R_NAND_Present = 0;
	MaxLUN = 0;

	__asm("fiq on");
	__asm("irq on");
	
	i = 0x0;
	if (i)
	{
		NandLowLevelFormat();
	}

	ret = NandInitial(0);
	if(ret)
		while(1);
	else
		R_NAND_Present=1;

	Nand_Part0_Size = GetNandSize();
	Nand_Part1_Size = 0;
	Nand_Part1_Offset = 0;
	Nand_Part2_Offset = 0;
	Unitab_Sector_Offset = Nand_Part2_Offset+Nand_Part2_Size;
	CalculateFATArea();  //add by haoyu for claculate fat size

	USB_Lun_Define[0].unLunNum = (unsigned int)0x00;
	USB_Lun_Define[0].unLunType = (unsigned int)LunType_NandDrive;
	USB_Lun_Define[0].ulNandStartAddr = (unsigned long)Nand_Part0_Offset;
	USB_Lun_Define[0].ulNandSizeSec =  Nand_Part0_Size;
	USB_Lun_Define[0].unStatus = (unsigned int)LunStatus_Normal;

	USB_Reset();
	USB_Initial();
	
	while(1)
	{		
		Key = SP_GetCh();				
		switch(Key)
		{										
			case 0x0100:
				break; 						
			case 0x0200:
				break;					
			case 0x0400:
				break;						
			case 0x0800:
				break;
			case 0x1000:
				break;					
			case 0x2000:
				break;		
			case 0x4000:
				break;		
			case 0x8000:
				break;																	
			default:
				break;				
		}
		USB_ServiceLoop(0);			//use usb loop		
		System_ServiceLoop();		//Keyboard Scan
		
		if(USBD_PlugIn)
		{
			//USB Plug in
		}
		else
		{
			//USB Plug out							
		}	
	}
	
	*P_USBD_Config=0x00;		//Close USB
	*P_USBD_INTEN=0x00;	
	return 0;
}


void Sys_Exception(int errorcode)
{
	while(1);
}
